/* ̸ ϵ  
#include "stdafx.h"
//*/

//* ܵ . stdafx.h Ʒ   ۼ 
#include <windows.h>
#include "SHRegistry.h"
#ifndef WINCE
#include <shlwapi.h>
#pragma comment(lib,"shlwapi")
#endif
//*/

//  д´. Ű   Ʈ Ѵ.
int CShRegistry::ShReadInt(HKEY Hive, LPCTSTR Key, LPCTSTR Value, INT Default)
{
	HKEY hKey;
	DWORD dwDisp;
	INT Result;
	DWORD cbSize;

	Result = Default;
	if (RegCreateKeyEx(Hive, Key, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
		if (dwDisp == REG_OPENED_EXISTING_KEY) {
			cbSize = sizeof(LONG);
			if (RegQueryValueEx(hKey, Value, 0, NULL, (LPBYTE)&Result, &cbSize) != ERROR_SUCCESS) {
				Result = Default;
			}
		}
		RegCloseKey(hKey);
	}
	return Result;
}

// ڿ д´.
bool CShRegistry::ShReadString(HKEY Hive, LPCTSTR Key, LPCTSTR Value, LPCTSTR Default, LPTSTR Ret, DWORD Size)
{
	HKEY hKey;
	DWORD dwDisp;
	DWORD cbSize;
	bool Result = false;

	if (RegCreateKeyEx(Hive, Key,0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
		if (dwDisp == REG_OPENED_EXISTING_KEY) {
			cbSize = Size * sizeof(TCHAR);
			if (RegQueryValueEx(hKey, Value, 0, NULL,(LPBYTE)Ret, &cbSize) == ERROR_SUCCESS) {
				Result = true;
			}
		}
		RegCloseKey(hKey);
	}

	if (Result == false) {
		lstrcpyn(Ret, Default, Size);
	}
	return Result;
}

// ڿ о CString Ѵ. ִ 256
#ifdef _MFC_VER
CString CShRegistry::ShReadString(HKEY Hive, LPCTSTR Key, LPCTSTR Value, LPCTSTR Default)
{
	TCHAR sTemp[256];
	if (ShReadString(Hive,Key,Value,Default,sTemp,256) == TRUE) {
		return CString(sTemp);
	} else {
		return CString(TEXT(""));
	}
}
#endif

//  .
bool CShRegistry::ShWriteInt(HKEY Hive, LPCTSTR Key, LPCTSTR Value, INT Data)
{
	HKEY hKey;
	DWORD dwDisp;
	bool Result = false;

	if (RegCreateKeyEx(Hive, Key, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
		if (RegSetValueEx(hKey, Value, 0, REG_DWORD, (LPBYTE)&Data, sizeof(INT)) == ERROR_SUCCESS) {
			Result = true;
		}
		RegCloseKey(hKey);
	}

	return Result;
}

// ڿ .
bool CShRegistry::ShWriteString(HKEY Hive, LPCTSTR Key, LPCTSTR Value, LPCTSTR Data)
{
	HKEY hKey;
	DWORD dwDisp;
	bool Result = false;

	if (RegCreateKeyEx(Hive, Key, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
		if (RegSetValueEx(hKey, Value, 0, REG_SZ, (LPBYTE)Data, (lstrlen(Data)+1)*sizeof(TCHAR)) == ERROR_SUCCESS) {
			Result = true;
		}
		RegCloseKey(hKey);
	}

	return Result;
}

// Ʈ Ű Ѵ.
bool CShRegistry::ShDeleteKey(HKEY Hive, LPCTSTR Key)
{
#ifdef WINCE
	return (RegDeleteKey(Hive,Key) == ERROR_SUCCESS);
#else
	return (SHDeleteKey(Hive,Key) == ERROR_SUCCESS);
#endif
}

//  Լ. ڿ  ̺ ƮŰ Ʒ Ű ׼Ѵ.
int CShRegistry::ReadInt(LPCTSTR SubKey, LPCTSTR Value, INT Default)
{
	TCHAR Key[MAX_PATH];

	wsprintf(Key,TEXT("%s\\%s"),Root,SubKey);
	return ShReadInt(HiveKey,Key,Value,Default);
}

bool CShRegistry::ReadString(LPCTSTR SubKey, LPCTSTR Value, LPCTSTR Default, LPTSTR Ret, DWORD Size)
{
	TCHAR Key[MAX_PATH];

	wsprintf(Key,TEXT("%s\\%s"),Root,SubKey);
	return ShReadString(HiveKey,Key,Value,Default,Ret,Size);
}

#ifdef _MFC_VER
CString CShRegistry::ReadString(LPCTSTR SubKey, LPCTSTR Value, LPCTSTR Default)
{
	TCHAR Key[MAX_PATH];

	wsprintf(Key,TEXT("%s\\%s"),Root,SubKey);
	return ShReadString(HiveKey,Key,Value,Default);
}
#endif

bool CShRegistry::WriteInt(LPCTSTR SubKey, LPCTSTR Value, INT Data)
{
	TCHAR Key[MAX_PATH];

	wsprintf(Key,TEXT("%s\\%s"),Root,SubKey);
	return ShWriteInt(HiveKey,Key,Value,Data);
}

bool CShRegistry::WriteString(LPCTSTR SubKey, LPCTSTR Value, LPCTSTR Data)
{
	TCHAR Key[MAX_PATH];

	wsprintf(Key,TEXT("%s\\%s"),Root,SubKey);
	return ShWriteString(HiveKey,Key,Value,Data);
}
